<?php

/* &irrec(ファイル名, ボタン文字列,CSS 文字列); が発見されると呼び出される。ボタンを生成する HTML を返す */
function plugin_irrec_inline() {
global  $vars,$script;

	 $args = func_get_args();
	 $fn  = $args[0];
	 $str = $args[1];
	 $stl = $args[2];
	 if (!$str) { $str=$fn; }

	 $page = $vars['page'];
	 	 
	 $str =
	 "<form action='$script' method='post' style='display:inline'>" .
	 "<input type='hidden' name='cmd' value='irrec' />" .
	 "<input type='hidden' name='str' value='$str' />" .
	 "<input type='hidden' name='fn'  value='$fn' />" .
	 "<input type='hidden' name='page' value='$page' />" .
	 "&nbsp;<input type='submit' value='*$str' style='background-color:pink;$stl' />" .
	 "</form>";
	 return $str;
}

/* ボタンが押されたときに呼び出される */
function plugin_irrec_action() {
  global $post, $vars, $script;

  // パラメータの取得
  $str = isset($vars['str']) ? htmlspecialchars($vars['str']) : '';
  $fn  = isset($vars['fn'])  ? htmlspecialchars($vars['fn']) : '';
  
  // コマンドの実行
  $fn_sjis = mb_convert_encoding($fn,"CP932", "UTF-8");  // 日本語ファイル名を SJIS に
  system("irdata\\V-IR.EXE R irdata\\$fn_sjis", $result);
  
  /* 空配列を返すと呼び出し元のページが表示される*/
  // return array('msg'=>'', 'body'=>'');
  
  /* msg でタイトル, body で本文を指定 */
  $link = $script . '?' . $vars['page'];


  if ($result==0) {
	return array('msg' =>  "赤外線信号の学習",
	'body' => "受信した信号を '$fn' に保存しました。<BR><A HREF='$link' alt='$link'>戻る</a>");
	} else {
		$cwd = getcwd();
		$str = "'$fn' を学習できませんでした。次の項目を確認して下さい<UL>" .
		"<LI>赤外線送受信モジュールは OS に正常に認識されていますか</LI>" .
		"<LI>データディレクトリ($cwd/irdata/)は存在していて、書き込み権はありますか</LI>" .
		"<LI>コマンド($cwd/irdata/V-IR)は存在していますか</LI>" .
		"<LI>コマンド($cwd/irdata/V-IR)は root に setuid されていますか(UNIX の場合)</LI>" .
		"</UL><BR><A HREF='$link' alt='$link'>戻る</a>";
		return array('msg' =>  "赤外線信号の学習", 'body' => $str);
	}
}
?>
